<?php
/*
Get the database ready and the navigation set.
*/
if (!@include_once("../includes/prefs.php")) {
	$pref_date = 'added';
	$pref_header = 1;
	$pref_footer = 1;
	$pref_greeting = "<p>Welcome to my Web site.  Click a thumbnail to ";
	$pref_greeting .= "jump into a section, or use the navigation links.</p>";
	$pref_columns = 3;
	$pref_site = '';
	$pref_copyright = '';
}
$pref_greeting = stripslashes($pref_greeting);
if (!@include_once("../includes/setup.php")) {
	$database_up = 0;
}
/*
v 1.1
Check for tables, if they don't exist, try to create them.
*/
function table_exists($find_this_table) {
	$tablenames = array();
	$tablelist = mysql_query("SHOW TABLES");
	while (list($tname) = mysql_fetch_row($tablelist)) {
		array_push($tablenames, $tname);
	}
	mysql_free_result($tablelist);
	if (in_array($find_this_table, $tablenames)) {
		return true;
	}
	return false;
}

$categories_ok = 0;
$categories_wrong_fields = 0;
$categories_not_created = 0;
$categories_table_created = 0;
$photos_wrong_fields = 0;
$photos_table_created = 0;
$photos_not_created = 0;
$photos_ok = 0;
$extended_fields_created = 0;
$extended_not_created = 0;

if (table_exists("categories")) {
	$query = "SHOW COLUMNS FROM categories";
	$result = mysql_query($query);
	$columns = array();
	while (list($field) = mysql_fetch_row($result)) {
		array_push($columns, $field);
	}
	mysql_free_result($result);
	if ((!in_array("category_id", $columns)) || (!in_array("photo_id", $columns)) ||
	(!in_array("title", $columns)) || (!in_array("description", $columns)) ||
	(!in_array("article", $columns))) {
		$categories_wrong_fields = 1;
	}
	else {
		$categories_ok = 1;
	}
}
else {
	$query = "CREATE TABLE categories (category_id int(11) NOT NULL auto_increment, ";
	$query .= "photo_id int(11) default NULL, title varchar(255) NOT NULL default 'Untitled', ";
	$query .= "description varchar(255) default NULL, article text, ";
	$query .= "PRIMARY KEY (category_id))";
	$result = mysql_query($query);
	if (table_exists("categories")) {
		$categories_table_created = 1;
	}
	else {
		$categories_not_created = 1;
	}
}

if (table_exists("photos")) {
	$query = "SHOW COLUMNS FROM photos";
	$result = mysql_query($query);
	$columns = array();
	while (list($field) = mysql_fetch_row($result)) {
		array_push($columns, $field);
	}
	mysql_free_result($result);
	if ((!in_array("photo_id", $columns)) || (!in_array("category_id", $columns)) ||
	(!in_array("day_added", $columns)) || (!in_array("day_taken", $columns)) ||
	(!in_array("filename", $columns)) || (!in_array("caption", $columns))) {
		$photos_wrong_fields = 1;
	}
	else {
		$photos_ok = 1;
		/*
		Time to check for v 1.1 extended fields.
		*/
		$extended_fields = 0;
		if (!in_array("film", $columns)) {
			$query = "ALTER TABLE photos ADD film VARCHAR(255)";
			$result = mysql_query($query);
			$query = "ALTER TABLE photos ADD INDEX (film)";
			$result = mysql_query($query);
			$extended_fields++;
		}
		if (!in_array("lens", $columns)) {
			$query = "ALTER TABLE photos ADD lens VARCHAR(255)";
			$result = mysql_query($query);
			$query = "ALTER TABLE photos ADD INDEX (lens)";
			$result = mysql_query($query);
			$extended_fields++;
		}
		if (!in_array("location", $columns)) {
			$query = "ALTER TABLE photos ADD location VARCHAR(255)";
			$result = mysql_query($query);
			$query = "ALTER TABLE photos ADD INDEX (location)";
			$result = mysql_query($query);
			$extended_fields++;
		}
		$query = "SHOW COLUMNS FROM photos";
		$result = mysql_query($query);
		$columns = array();
		while (list($field) = mysql_fetch_row($result)) {
			array_push($columns, $field);
		}
		mysql_free_result($result);
		if ((in_array("film", $columns)) && (in_array("lens", $columns)) && 
		(in_array("location", $columns))) {
			$extended_fields_created = 1;
		}
		else {
			$extended_not_created = 1;
		}
	}
}
else {
	$feedback .= "photos doesn't exist, make it";
	$query = "CREATE TABLE photos (photo_id int(11) NOT NULL auto_increment, ";

	$query .= "category_id int(11) NOT NULL, day_added timestamp(14) NOT NULL, ";
	$query .= "day_taken date default NULL, filename varchar(255) NOT NULL, ";
	$query .= "caption varchar(255) default NULL, film varchar(255) default NULL, ";
	$query .= "lens varchar(255) default NULL, location varchar(255) default NULL, ";
	$query .= "PRIMARY KEY (photo_id), KEY category_id (category_id))";
	$result = mysql_query($query);
	if (table_exists("photos")) {
		$photos_table_created = 1;
	}
	else {
		$photos_not_created = 1;
	}
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>

<head>
<title><?=$pref_site?>: <?=$section?></title>
<link rel="stylesheet" type="text/css" href="../stylesheets/default.css">
</head>

<body>

<div id="header">
<h1><?=$pref_site?>: <span style="color: gray"><?=$section?></span></h1>
<p><?=$nav_header?></p>
</div>

<div id="content">

<h2>Admin page</h2>

<?php
if ($photos_not_created) {
?>

<p><span style="color:red;weight:bolder">Bad news!</span>  The photos table 
was not found.  PHPortfolio tried to create the table, but failed.  
At this point, PHPortfolio is stuck.  Recheck the setup.php file and reload 
this page.  Or create a new database for PHPortfolio, update the setup.php 
file to use it, and reload this page.  If you still don't have any luck, 
you'll need to talk to someone in charge of the database.  It's possible 
your account isn't allowed to create tables.</p>

<?php
}
if ($photos_ok) {
?>

<p>Photos table working properly.</p>

<?php
}
if ($categories_ok) {
?>

<p>Categories table working properly.</p>

<?php
}
if ($photos_table_created) {
?>

<p><span style="color:green;weight:bolder">Good news!</span>  The photos 
table was not found, but PHPortfolio was able to create it for you.</p>

<?php
}
if ($photos_wrong_fields) {
?>

<p><span style="color:red;weight:bolder">Bad news!</span>  Although a photos 
table does exist, it is not one PHPortfolio can use.  If you are certain you 
don't need the existing table, you can delete it manually and reload this 
page.  Or create a new database, update the setup.php file to use it, and 
reload this page.</p>

<!-- 
Or PHPortfolio can create a new database for the photos & categories 
tables.  However, if you do not manage the Web server yourself, you may find 
that your Web hosting provider limits the number of databases you can create, 
or may charge you extra.  If you are comfortable with this option, 
<a href="index.php?action=new">use PHPortfolio to create a new database</a>.
 -->

<?php
}
if ($extended_fields && $extended_fields_created) {
?>

<p><span style="color:green;weight:bolder">Good news!</span>  PHPortfolio 
has upgraded your photos table to use the extra PHPortfolio 1.1 fields 
(film, lens, location).</p>

<?php
}
if ($extended_fields && $extended_not_created) {
?>

<p><span style="color:red;weight:bolder">Bad news!</span>  PHPortfolio 
attempted to upgrade the photos table, adding the PHPortfolio 1.1 fields.  
This failed.  While your table still exists, it does not have the new fields, 
and will not be compatible with PHPortfolio 1.1.  You can roll back to 
PHPortfolio 1.0, or possibly talk to someone in charge of the database.  Your 
account probably doesn't have ALTER rights, but PHPortfolio needs that.  If 
you can solve that issue, reload this Web page & PHPortfolio will try again.</p>

<?php
}
if ($categories_table_created) {
?>

<p><span style="color:green;weight:bolder">Good news!</span>  The categories 
table was not found, but PHPortfolio was able to create it for you.</p>

<?php
}
if ($categories_not_created) {
?>

<p><span style="color:red;weight:bolder">Bad news!</span>  The categories 
table was not found.  PHPortfolio tried to create the table, but failed.  
At this point, PHPortfolio is stuck.  Recheck the setup.php file and reload 
this page.  Or create a new database for PHPortfolio, update the setup.php 
file to use it, and reload this page.  If you still don't have any luck, 
you'll need to talk to someone in charge of the database.  It's possible 
your account isn't allowed to create tables.</p>

<?php
}
if ($categories_wrong_fields) {
?>

<p><span style="color:red;weight:bolder">Bad news!</span>  Although a photos 
table does exist, it is not one PHPortfolio can use.  If you are certain you 
don't need the existing table, you can delete it manually and reload this 
page.  Or create a new database, update the setup.php file to use it, and 
reload this page.</p>

<!-- 
Or PHPortfolio can create a new database for the photos & categories 
tables.  However, if you do not manage the Web server yourself, you may find 
that your Web hosting provider limits the number of databases you can create, 
or may charge you extra.  If you are comfortable with this option, 
<a href="index.php?action=new">use PHPortfolio to create a new database</a>.
 -->

<?php
}
?>

<p><a href="categories.php">Create/edit categories</a></p>

<p><a href="photos.php">Work with the photos</a></p>

<p><a href="settings.php">Preferences</a></p>

</div>

<div id="footer">
<p><?=$nav_footer?></p>
<p class="copyright"><?=$pref_copyright?></p>
<p style="color:gray;font-size:smaller">Powered by <a href="http://www.outshine.com/phportfolio/">PHPortfolio</a>.  
Available for free under a BSD-style license.</p>
</div>

</body>
</html>
