<?php
/*
Get the database ready and the navigation set.
*/
if (!@include_once("../includes/prefs.php")) {
	$pref_date = 'added';
	$pref_header = 1;
	$pref_footer = 1;
	$pref_greeting = "<p>Welcome to my Web site.  Click a thumbnail to ";
	$pref_greeting .= "jump into a section, or use the navigation links.</p>";
	$pref_columns = 3;
	$pref_site = '';
	$pref_copyright = '';
	$pref_thumbsize = 100;
	$pref_thumbquality = 80;
}
/*
v 1.3
Just some friendly checks in case someone upgraded to 1.3, but still has a
version 1.2 prefs.php file.
*/
if (!isset($pref_thumbsize)) {
	$pref_thumbsize = 100;
}
if (!isset($pref_thumbquality)) {
	$pref_thumbquality = 80;
}
$pref_greeting = stripslashes($pref_greeting);
if (!@include_once("../includes/setup.php")) {
	$database_up = 0;
}

/*
Set up default values.
*/
$id = (isset($_GET['id'])) ? $_GET['id'] : '';
$category = (isset($_GET['category'])) ? $_GET['category'] : '';
$title = '';
$day_taken = '';
$filename = '';
$caption = '';
/*
v 1.1
Added $film, $lens, $locale.
*/
$film = '';
$lens = '';
$locale = '';
$next_action = '';
$message = '';
$show = '';

/*
Now change those defaults based upon what the user wants to do.
*/
include_once("../includes/photo_setup.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>

<head>
<title><?=$pref_site?>: <?=$section?></title>
<link rel="stylesheet" type="text/css" href="../stylesheets/default.css">
</head>

<body>

<div id="header">
<h1><?=$pref_site?>: <span style="color: gray"><?=$section?></span></h1>
<p><?=$nav_header?></p>
</div>

<div id="content">

<?=$message?>

<?php
if ($show == 'photos') {
?>

<p><a href="photos.php?action=add&category=<?=$category?>">Add a new photo</a></p>

<table border="0" cellpadding="5" cellspacing="0">

<tr>
<th>photo</th>
<th>edit</th>
<th>delete</th>
</tr>

<?php
	$query = "SELECT photo_id, filename, caption FROM photos WHERE category_id='$category'";
	$result = mysql_query($query);
	while (list($id, $filename, $caption) = mysql_fetch_row($result)) {
?>

<tr>
<td><img alt="<?=$caption?>" border="0" src="../images/small_<?=$filename?>"></td>
<td><a href="photos.php?action=edit&id=<?=$id?>">edit</a></td>
<td><a href="photos.php?action=delete&id=<?=$id?>">delete</a></td>
</tr>

<?php
	}
?>

</table>

<?php
}
else if ($show == 'form') {
	$query = 'SELECT category_id, title FROM categories ORDER BY title';
	$result = mysql_query($query);
	while (list($cid, $title) = mysql_fetch_row($result)) {
		$checked = ($cid == $category) ? ' selected="selected"' : '';
		$options .= "<option value='$cid'$checked>$title</option>\n";
	}
	$thumbnail = '';
	if ($next_action == 'update') {
		$query = "SELECT filename FROM photos WHERE photo_id='$id'";
		$result = mysql_query($query);
		list($thumbnail) = mysql_fetch_row($result);
		$thumbnail = "<img src='../images/small_" . $thumbnail . "' />";
	}
?>

<form enctype="multipart/form-data" action="photos.php" method="post">

<input type='hidden' name='action' value='<?=$next_action?>' />
<input type='hidden' name='id' value='<?=$id?>' />
<input type="hidden" name="MAX_FILE_SIZE" value="20970000">

<?=$thumbnail?>

<table>

<tr>
<td align='right'>category</td>
<td><select name='category'>
<?=$options?>
</select></td>
</tr>

<tr>
<td align='right'>thumbnail image</td>
<td>Leave this blank, and a thumbnail will be generated for you.<br />
<input type="file" name="smallphoto"></td>
</tr>

<tr>
<td align='right'>full-size image</td>
<td><input type="file" name="bigphoto"></td>
</tr>

<tr>
<td align='right'>date taken (optional)</td>
<td><input type='text' maxlength='255' name='day_taken' size='40' value="<?=htmlspecialchars($day_taken)?>" /><br>
<small>example: 2003-12-31</small></td>
</tr>

<tr>
<td align='right'>caption (optional)</td>
<td><input type='text' maxlength='255' name='caption' size='40' value="<?=htmlspecialchars($caption)?>" /></td>
</tr>

<tr>
<td align='right'>film (optional)</td>
<td><input type='text' maxlength='255' name='film' size='40' value="<?=htmlspecialchars($film)?>" /></td>
</tr>

<tr>
<td align='right'>lens (optional)</td>
<td><input type='text' maxlength='255' name='lens' size='40' value="<?=htmlspecialchars($lens)?>" /></td>
</tr>

<tr>
<td align='right'>location (optional)</td>
<td><input type='text' maxlength='255' name='location' size='40' value="<?=htmlspecialchars($locale)?>" /></td>
</tr>

</table>

<input type="submit">

</form>

<?php
}
else if ($show == 'confirm') {
	$query = 'SELECT category_id, day_taken, filename, caption FROM photos WHERE ';
	$query .= "photo_id=$id";
	$result = mysql_query($query);
	list($cat, $day_taken, $filename, $caption) = mysql_fetch_row($result);
?>

<p>Are you sure you wish to <strong>delete this photo</strong>?  You can 
view the photo details at the bottom of this page.  Click the confirm 
button, or else use the navigation links above to bail out.</p>

<form action="photos.php" method="get">

<input name="id" type="hidden" value="<?=$id?>" />
<input name="category" type="hidden" value="<?=$cat?>" />
<input name="action" type="hidden" value="confirm" />

<input type="submit" value="confirm" />

</form>

<hr>

<table>

<tr>
<td align="right" valign="top">thumbnail:</td>
<td><img src="../images/small_<?=$filename?>"></td>
</tr>

<tr>
<td align="right" valign="top">day taken:</td>
<td><?=$day_taken?></td>
</tr>

<tr>
<td align="right" valign="top">caption:</td>
<td><?=$caption?></td>
</tr>

</table>

<?php
}
else {
	echo "<p>";
	$query = "SELECT category_id, title FROM categories ORDER BY title";
	$result = mysql_query($query);
	while (list($cid, $title) = mysql_fetch_row($result)) {
?>

<a href="photos.php?action=view&category=<?=$cid?>"><?=$title?></a><br />

<?php
	}
	echo "</p>";
}
?>

</div>

<div id="footer">
<p><?=$nav_footer?></p>
<p class="copyright"><?=$pref_copyright?></p>
<p style="color:gray;font-size:smaller">Powered by <a href="http://www.outshine.com/phportfolio/">PHPortfolio</a>.  
Available for free under a BSD-style license.</p>
</div>

</body>
</html>
